local E, L, V, P, G, _ = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore

ElvUF.Tags.Events['mClass'] = "UNIT_CLASSIFICATION_CHANGED"
ElvUF.Tags.Methods['mClass'] = function(unit)
	local c = UnitClassification(unit)

	if(c == 'rare') then
		return '|cffFA5882Rare |r' 
	elseif(c == 'rareelite') then
		return '|cffFA5882Rare Elite |r' 
	elseif(c == 'elite') then
		return '|cff642EFEElite |r'
	elseif(c == 'worldboss') then
		return '|cffFF0040Boss |r'
	end
end

ElvUF.Tags.Events['mHealth'] = "UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'"
ElvUF.Tags.Methods['mHealth'] = function(unit)
	local isAFK = UnitIsAFK(unit)
	
	if isAFK then
		return ('|cffFFFFFF[|r|cffFF0000%s|r|cFFFFFFFF]|r'):format(DEFAULT_AFK_MESSAGE)
	else
		local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
		if (status) then
			return status
		else
			local currentHealth = UnitHealth(unit)
			local deficit = UnitHealthMax(unit) - currentHealth

			if (deficit > 0 and currentHealth > 0) then
				return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
			else
				return E:GetFormattedText('CURRENT', UnitHealth(unit), UnitHealthMax(unit))
			end
		end
	end
end

ElvUF.Tags.Events['mRole'] = 'PLAYER_ROLES_ASSIGNED GROUP_ROSTER_UPDATE'
ElvUF.Tags.Methods['mRole'] = function(unit)
	local Role = UnitGroupRolesAssigned(unit)
	local String = ''

	if Role == 'TANK' then
		String = '|cff0099CC(' .. TANK .. ')|r'
	elseif Role == 'HEALER' then
		String = '|cff00FF00(' .. HEALER .. ')|r'
	end

	return String
end

ElvUF.Tags.Events['mLevel'] = 'UNIT_LEVEL PLAYER_LEVEL_UP PLAYER_UPDATE_RESTING'
ElvUF.Tags.Methods['mLevel'] = function(unit)
	if(unit == 'player' and IsResting()) then
		return '|cfff7d358Zzz|r'
	else
		local level = UnitLevel(unit)
	if ( UnitIsWildBattlePet(unit) or UnitIsBattlePetCompanion(unit) ) then
		return UnitBattlePetLevel(unit);
	elseif(level > 0) then
		return level
	else
		return '|cffff1e24??|r'
	end
	end
end

ElvUF.Tags.Events['health:deficit-percent:name'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['health:deficit-percent:name'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local deficit = UnitHealthMax(unit) - currentHealth

	if (deficit > 0 and currentHealth > 0) then
		return _TAGS["health:percent-nostatus"](unit)
	else
		return _TAGS["name"](unit)
	end
end

ElvUF.Tags.Events['mRole'] = 'PLAYER_ROLES_ASSIGNED GROUP_ROSTER_UPDATE'
ElvUF.Tags.Methods['mRole'] = function(unit)
	local Role = UnitGroupRolesAssigned(unit)
	local String = ''

	if Role == 'TANK' then
		String = '|cff0099CC(' .. TANK .. ')|r'
	elseif Role == 'HEALER' then
		String = '|cff00FF00(' .. HEALER .. ')|r'
	end

	return String
end

ElvUF.Tags.Events['mRole:short'] = 'PLAYER_ROLES_ASSIGNED GROUP_ROSTER_UPDATE'
ElvUF.Tags.Methods['mRole:short'] = function(unit)
	local Role = UnitGroupRolesAssigned(unit)
	local String = ''

	if Role == 'TANK' then
		String = '|cff0099CC(' .. E:ShortenString(TANK, 1) .. ')|r'
	elseif Role == 'HEALER' then
		String = '|cff00FF00(' .. E:ShortenString(HEALER, 1) .. ')|r'
	end
	
	return String
end

ElvUF.Tags.Events['mGroup'] = 'GROUP_ROSTER_UPDATE'
ElvUF.Tags.Methods['mGroup'] = function(unit)
	local name, server = UnitName(unit)
	local i = 0
			
	if(server and server ~= "") then
		name = format("%s-%s", name, server)
	end

	for i=1, GetNumGroupMembers() do
		local raidName, _, group = GetRaidRosterInfo(i)
		if( raidName == name ) then
			return 'Grp.: ' .. group .. ''
		end
	end
end